#ifndef GABA_DEFINE
struct userauth
{
  struct lsh_object super;
  void (*(authenticate))(struct userauth *self, struct ssh_connection *connection, struct lsh_string *username, struct simple_buffer *args, struct command_continuation *c, struct exception_handler *e);
};
extern struct lsh_class userauth_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class userauth_class =
{ STATIC_HEADER,
  0, "userauth", sizeof(struct userauth),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct userauth_special_exception
{
  struct exception super;
  struct lsh_string *reply;
};
extern struct lsh_class userauth_special_exception_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_userauth_special_exception_free(struct lsh_object *o)
{
  struct userauth_special_exception *i = (struct userauth_special_exception *) o;
  lsh_string_free(i->reply);
}

struct lsh_class userauth_special_exception_class =
{ STATIC_HEADER,
  &exception_class, "userauth_special_exception", sizeof(struct userauth_special_exception),
  NULL,
  do_userauth_special_exception_free
};
#endif /* !GABA_DECLARE */

